searchNodes=[{"doc":"Simple, fast, flexible and efficient generation of probably unique identifiers ( puid , aka random strings) of intuitively specified entropy using pre-defined or custom characters. Overview Puid provides fast and efficient generation of random IDs. For the purposes of Puid , a random ID is considered a random string used in a context of uniqueness, that is, random IDs are a bunch of random strings that are hopefully unique. Random string generation can be thought of as a transformation of some random source of entropy into a string representation of randomness. A general purpose random string library used for random IDs should therefore provide user specification for each of the following three key aspects: Entropy source What source of randomness is being transformed? Puid allows easy specification of the function used for source randomness. ID characters What characters are used in the ID? Puid provides 16 pre-defined character sets, as well as allows custom character designation, including Unicode ID randomness What is the resulting “randomness” of the IDs? Note this isn't necessarily the same as the randomness of the entropy source. Puid allows explicit specification of ID randomness in an intuitive manner. Examples Creating a random ID generator using Puid is a simple as: iex&gt; defmodule ( RandId , do : use ( Puid ) ) iex&gt; RandId . generate ( ) &quot;8nGA2UaIfaawX-Og61go5A&quot; Options allow easy and complete control of ID generation. Entropy Source Puid uses :crypto.strong_rand_bytes/1 as the default entropy source. The rand_bytes option can be used to specify any function of the form (non_neg_integer) -&gt; binary as the source: iex &gt; defmodule ( PrngPuid , do : use ( Puid , rand_bytes : &amp; :rand . bytes / 1 ) ) iex&gt; PrngPuid . generate ( ) &quot;bIkrSeU6Yr8_1WHGvO0H3M&quot; ID Characters By default, Puid use the RFC 4648 file system &amp; URL safe characters. The chars option can by used to specify any of 16 pre-defined character sets or custom characters, including Unicode: iex&gt; defmodule ( HexPuid , do : use ( Puid , chars : :hex ) ) iex&gt; HexPuid . generate ( ) &quot;13fb81e35cb89e5daa5649802ad4bbbd&quot; iex&gt; defmodule ( DingoskyPuid , do : use ( Puid , chars : &quot;dingosky&quot; ) ) iex&gt; DingoskyPuid . generate ( ) &quot;yiidgidnygkgydkodggysonydodndsnkgksgonisnko&quot; iex&gt; defmodule ( DingoskyUnicodePuid , do : use ( Puid , chars : &quot;dîñgø$kyDÎÑGØßK¥&quot; , total : 2.5e6 , risk : 1.0e15 ) ) iex&gt; DingoskyUnicodePuid . generate ( ) &quot;øßK$ggKñø$dyGîñdyØøØÎîk&quot; ID Randomness Generated IDs have 128-bit entropy by default. Puid provides a simple, intuitive way to specify ID randomness by declaring a total number of possible IDs with a specified risk of a repeat in that many IDs: To generate up to 10 million random IDs with 1 in a trillion chance of repeat: iex&gt; defmodule ( MyPuid , do : use ( Puid , total : 10.0e6 , risk : 1.0e15 ) ) iex&gt; MyPuid . generate ( ) &quot;T0bFZadxBYVKs5lA&quot; The bits option can be used to directly specify an amount of ID randomness: iex&gt; defmodule ( Token , do : use ( Puid , bits : 256 , chars : :hex_upper ) ) iex&gt; Token . generate ( ) &quot;6E908C2A1AA7BF101E7041338D43B87266AFA73734F423B6C3C3A17599F40F2A&quot; Module API Puid modules have two functions: iex&gt; defmodule ( AlphanumId , do : use ( Puid , total : 10.0e06 , risk : 1.0e15 , chars : :alphanum ) ) generate/0 Generates a puid iex&gt; AlphanumId . generate ( ) &quot;UKQHTmvASwyhcwGNA&quot; info/0 Returns a Puid.Info structure consisting of Name of pre-defined Puid.Chars or :custom Source characters Entropy bits May be larger than the specified bits since it is a multiple of the entropy bits per character Entropy bits per character Entropy representation efficiency Ratio of the puid entropy to the bits required for string representation puid string length Entropy source function iex&gt; AlphanumId . info ( ) % Puid.Info { char_set : :alphanum , characters : &quot;ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789&quot; , entropy_bits : 101.22 , entropy_bits_per_char : 5.95 , ere : 0.74 , length : 17 , rand_bytes : &amp; :crypto . strong_rand_bytes / 1 }","ref":"Puid.html","title":"Puid","type":"module"},{"doc":"Pre-defined character sets for use when creating Puid modules. Example iex&gt; defmodule ( AlphanumId , do : use ( Puid , chars : :alphanum ) ) Pre-defined Chars :alpha Upper/lower case alphabet ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz :alpha_lower Lower case alphabet abcdefghijklmnopqrstuvwxyz :alpha_upper Upper case alphabet ABCDEFGHIJKLMNOPQRSTUVWXYZ :alphanum Upper/lower case alphabet and numbers ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 :alphanum_lower Lower case alphabet and numbers abcdefghijklmnopqrstuvwxyz0123456789 :alphanum_upper Upper case alphabet and numbers ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 :base32 RFC 4648 base32 character set ABCDEFGHIJKLMNOPQRSTUVWXYZ234567 :base32_hex RFC 4648 base32 extended hex character set with lowercase letters 0123456789abcdefghijklmnopqrstuv :base32_hex_upper RFC 4648 base32 extended hex character set 0123456789ABCDEFGHIJKLMNOPQRSTUV :decimal Decimal digits 0123456789 :hex Lowercase hexadecimal 0123456789abcdef :hex_upper Uppercase hexadecimal 0123456789ABCDEF :safe_ascii ASCII characters from ?! to ?~ , minus backslash, backtick, single-quote and double-quote `!#$%&amp;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_\abcdefghijklmnopqrstuvwxyz{|}~` :safe32 Strings that don't look like English words and are easy to parse visually 2346789bdfghjmnpqrtBDFGHJLMNPQRT remove all upper and lower case vowels (including y) remove all numbers that look like letters remove all letters that look like numbers remove all letters that have poor distinction between upper and lower case values :safe64 RFC 4648 file system and URL safe character set ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_ :symbol :safe_ascii characters not in :alphanum `!#$%&amp;()*+,-./:;&lt;=&gt;?@[]^_{|}~`","ref":"Puid.Chars.html","title":"Puid.Chars","type":"module"},{"doc":"Same as charlist/1 but either returns charlist or raises a Puid.Error Example iex&gt; Puid.Chars . charlist! ( :safe32 ) &#39;2346789bdfghjmnpqrtBDFGHJLMNPQRT&#39; iex&gt; Puid.Chars . charlist! ( &quot;dingosky&quot; ) &#39;dingosky&#39; iex&gt; Puid.Chars . charlist! ( &quot;unique&quot; ) # (Puid.Error) Characters not unique","ref":"Puid.Chars.html#charlist!/1","title":"Puid.Chars.charlist!/1","type":"function"},{"doc":"charlist for a pre-defined Puid.Chars , a String.t() or a charlist. The characters for either String.t() or charlist types must be unique and must have more than one character. It is assumed each character has equal probability of occurrence, which maximizes entropy. Example iex&gt; Puid.Chars . charlist ( :safe32 ) { :ok , &#39;2346789bdfghjmnpqrtBDFGHJLMNPQRT&#39; } iex&gt; Puid.Chars . charlist ( &quot;dingosky&quot; ) { :ok , &#39;dingosky&#39; } iex&gt; Puid.Chars . charlist ( &quot;unique&quot; ) { :error , &quot;Characters not unique&quot; }","ref":"Puid.Chars.html#charlist/1","title":"Puid.Chars.charlist/1","type":"function"},{"doc":"Chars can be designated by a pre-defined atom, a binary or a charlist","ref":"Puid.Chars.html#t:puid_chars/0","title":"Puid.Chars.puid_chars/0","type":"type"},{"doc":"Character encoding scheme. :ascii encoding uses cross-product character pairs.","ref":"Puid.Chars.html#t:puid_encoding/0","title":"Puid.Chars.puid_encoding/0","type":"type"},{"doc":"Entropy related calculations The implementation is based on mathematical approximations to the solution of what is often referred to as the Birthday Problem .","ref":"Puid.Entropy.html","title":"Puid.Entropy","type":"module"},{"doc":"Entropy bits for generating a total number of events with the given risk of repeat The total size of the event pool is 2&lt;sup&gt;bits&lt;/sup&gt;. Example iex&gt; Puid.Entropy . bits ( 10.0e6 , 1.0e12 ) 85.37013046707142","ref":"Puid.Entropy.html#bits/2","title":"Puid.Entropy.bits/2","type":"function"},{"doc":"Same as Puid.Entropy.bits_for_len/2 but either returns bits or raises a Puid.Error Example iex&gt; Puid.Entropy . bits_for_len! ( :alphanum , 14 ) 83 iex&gt; Puid.Entropy . bits_for_len! ( &quot;dingosky&quot; , 14 ) 42","ref":"Puid.Entropy.html#bits_for_len!/2","title":"Puid.Entropy.bits_for_len!/2","type":"function"},{"doc":"Entropy bits for a binary of length len comprised of chars characters. chars must be valid as per Chars.charlist/1 . Example iex&gt; Puid.Entropy . bits_for_len ( :alphanum , 14 ) { :ok , 83 } iex&gt; Puid.Entropy . bits_for_len ( &#39;dingosky&#39; , 14 ) { :ok , 42 }","ref":"Puid.Entropy.html#bits_for_len/2","title":"Puid.Entropy.bits_for_len/2","type":"function"},{"doc":"Same as bits_per_char/1 but either returns bits or raises a Puid.Error Example iex&gt; Puid.Entropy . bits_per_char! ( :alphanum ) 5.954196310386875 Puid.Entropy . bits_per_char! ( &quot;dingosky&quot; ) 3.0","ref":"Puid.Entropy.html#bits_per_char!/1","title":"Puid.Entropy.bits_per_char!/1","type":"function"},{"doc":"Entropy bits per chars character. chars must be valid as per Chars.charlist/1 . Example iex&gt; Puid.Entropy . bits_per_char ( :alphanum ) { :ok , 5.954196310386875 } iex&gt; Puid.Entropy . bits_per_char ( &quot;dingosky&quot; ) { :ok , 3.0 }","ref":"Puid.Entropy.html#bits_per_char/1","title":"Puid.Entropy.bits_per_char/1","type":"function"},{"doc":"Same as Puid.Entropy.len_for_bits/2 but either returns len or raises a Puid.Error Example iex&gt; Puid.Entropy . len_for_bits! ( :alphanum , 128 ) 22 iex&gt; Puid.Entropy . len_for_bits! ( &#39;dingosky&#39; , 128 ) 43","ref":"Puid.Entropy.html#len_for_bits!/2","title":"Puid.Entropy.len_for_bits!/2","type":"function"},{"doc":"Length needed for a string generated from chars to have entropy bits . chars must be valid as per Chars.charlist/1 . Example iex&gt; Puid.Entropy . len_for_bits ( :alphanum , 128 ) { :ok , 22 } iex&gt; Puid.Entropy . len_for_bits ( &quot;dingosky&quot; , 128 ) { :ok , 43 }","ref":"Puid.Entropy.html#len_for_bits/2","title":"Puid.Entropy.len_for_bits/2","type":"function"},{"doc":"","ref":"Puid.Entropy.html#t:puid_chars/0","title":"Puid.Entropy.puid_chars/0","type":"type"},{"doc":"Information regarding Puid module parameterization The Puid.Info struct has the following fields: Field Description char_set pre-defined Puid.Chars atom or :custom characters source characters entropy_bits entropy bits for generated puid entropy_bits_per_char entropy bits per character for generated puid s ere puid entropy string representation efficiency length puid string length rand_bytes entropy source function iex&gt; defmodule ( CustomId , do : use ( Puid , total : 1.0e04 , risk : 1.0e12 , chars : &quot;thequickbrownfxjmpsvlazydg&quot; ) ) iex&gt; CustomId . info ( ) % Puid.Info { char_set : :custom , characters : &quot;thequickbrownfxjmpsvlazydg&quot; , entropy_bits : 65.81 , entropy_bits_per_char : 4.7 , ere : 0.59 , length : 14 , rand_bytes : &amp; :crypto . strong_rand_bytes / 1 }","ref":"Puid.Info.html","title":"Puid.Info","type":"module"},{"doc":"Raised when defining a Puid module with invalid options","ref":"Puid.Error.html","title":"Puid.Error","type":"exception"},{"doc":"Puid.Error type","ref":"Puid.Error.html#t:t/0","title":"Puid.Error.t/0","type":"type"}]